<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (12)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="basic-operators-maths">Basic operators, maths</h1>
    <p>
      We know many operators from school. They are things like addition
      <code>+</code>, multiplication <code>*</code>, subtraction <code>-</code>,
      and so on.
    </p>
    <p>
      In this chapter, we’ll start with simple operators, then concentrate on
      JavaScript-specific aspects, not covered by school arithmetic.
    </p>
    <h2 id="terms-unary-binary-operand">Terms: “unary”, “binary”, “operand”</h2>
    <p>Before we move on, let’s grasp some common terminology.</p>
    <ul>
      <li>
        <em>An operand</em> – is what operators are applied to. For instance, in
        the multiplication of <code>5 * 2</code> there are two operands: the
        left operand is <code>5</code> and the right operand is <code>2</code>.
        Sometimes, people call these “arguments” instead of “operands”.
      </li>
      <li>
        <p>
          An operator is <em>unary</em> if it has a single operand. For example,
          the unary negation <code>-</code> reverses the sign of a number:
        </p>
        <p>```js run let x = 1;</p>
        <p>
          <em>!</em> x = -x; <em>/!</em> alert( x ); // -1, unary negation was
          applied ```
        </p>
      </li>
      <li>
        <p>
          An operator is <em>binary</em> if it has two operands. The same minus
          exists in binary form as well:
        </p>
        <p>
          <code
            >js run no-beautify let x = 1, y = 3; alert(y - x); // 2, binary
            minus subtracts values</code
          >
        </p>
        <p>
          Formally, in the examples above we have two different operators that
          share the same symbol: the negation operator, a unary operator that
          reverses the sign, and the subtraction operator, a binary operator
          that subtracts one number from another.
        </p>
      </li>
    </ul>
    <h2 id="maths">Maths</h2>
    <p>The following math operations are supported:</p>
    <ul>
      <li>Addition <code>+</code>,</li>
      <li>Subtraction <code>-</code>,</li>
      <li>Multiplication <code>*</code>,</li>
      <li>Division <code>/</code>,</li>
      <li>Remainder <code>%</code>,</li>
      <li>Exponentiation <code>**</code>.</li>
    </ul>
    <p>
      The first four are straightforward, while <code>%</code> and
      <code>**</code> need a few words about them.
    </p>
    <h3 id="remainder">Remainder %</h3>
    <p>
      The remainder operator <code>%</code>, despite its appearance, is not
      related to percents.
    </p>
    <p>
      The result of <code>a % b</code> is the
      <a href="https://en.wikipedia.org/wiki/Remainder">remainder</a> of the
      integer division of <code>a</code> by <code>b</code>.
    </p>
    <p>For instance:</p>
    <p>
      <code
        >js run alert(5 % 2); // 1, a remainder of 5 divided by 2 alert(8 % 3);
        // 2, a remainder of 8 divided by 3</code
      >
    </p>
    <h3 id="exponentiation">Exponentiation **</h3>
    <p>
      The exponentiation operator <code>a ** b</code> raises <code>a</code> to
      the power of <code>b</code>.
    </p>
    <p>In school maths, we write that as a<sup>b</sup>.</p>
    <p>For instance:</p>
    <p>
      <code
        >js run alert(2 ** 2); // 2² = 4 alert(2 ** 3); // 2³ = 8 alert(2 ** 4);
        // 2⁴ = 16</code
      >
    </p>
    <p>
      Just like in maths, the exponentiation operator is defined for non-integer
      numbers as well.
    </p>
    <p>For example, a square root is an exponentiation by ½:</p>
    <p>
      <code
        >js run alert(4 ** (1 / 2)); // 2 (power of 1/2 is the same as a square
        root) alert(8 ** (1 / 3)); // 2 (power of 1/3 is the same as a cubic
        root)</code
      >
    </p>
    <h2 id="string-concatenation-with-binary">
      String concatenation with binary +
    </h2>
    <p>
      Let’s meet features of JavaScript operators that are beyond school
      arithmetics.
    </p>
    <p>Usually, the plus operator <code>+</code> sums numbers.</p>
    <p>
      But, if the binary <code>+</code> is applied to strings, it merges
      (concatenates) them:
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> s <span class="op">=</span> <span class="st">&quot;my&quot;</span> <span class="op">+</span> <span class="st">&quot;string&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="at">alert</span>(s)<span class="op">;</span> <span class="co">// mystring</span></a></code></pre>
    </div>
    <p>
      Note that if any of the operands is a string, then the other one is
      converted to a string too.
    </p>
    <p>For example:</p>
    <p><code>js run alert("1" + 2); // "12" alert(2 + "1"); // "21"</code></p>
    <p>
      See, it doesn’t matter whether the first operand is a string or the second
      one.
    </p>
    <p>Here’s a more complex example:</p>
    <p><code>js run alert(2 + 2 + "1"); // "41" and not "221"</code></p>
    <p>
      Here, operators work one after another. The first <code>+</code> sums two
      numbers, so it returns <code>4</code>, then the next <code>+</code> adds
      the string <code>1</code> to it, so it’s like <code>4 + '1' = '41'</code>.
    </p>
    <p><code>js run alert("1" + 2 + 2); // "122" and not "14"</code></p>
    <p>
      Here, the first operand is a string, the compiler treats the other two
      operands as strings too. The <code>2</code> gets concatenated to
      <code>'1'</code>, so it’s like <code>'1' + 2 = "12"</code> and
      <code>"12" + 2 = "122"</code>.
    </p>
    <p>
      The binary <code>+</code> is the only operator that supports strings in
      such a way. Other arithmetic operators work only with numbers and always
      convert their operands to numbers.
    </p>
    <p>Here’s the demo for subtraction and division:</p>
    <p>
      <code
        >js run alert(6 - "2"); // 4, converts '2' to a number alert("6" / "2");
        // 3, converts both operands to numbers</code
      >
    </p>
    <h2 id="numeric-conversion-unary">Numeric conversion, unary +</h2>
    <p>
      The plus <code>+</code> exists in two forms: the binary form that we used
      above and the unary form.
    </p>
    <p>
      The unary plus or, in other words, the plus operator
      <code>+</code> applied to a single value, doesn’t do anything to numbers.
      But if the operand is not a number, the unary plus converts it into a
      number.
    </p>
    <p>For example:</p>
    <p>```js run // No effect on numbers let x = 1; alert( +x ); // 1</p>
    <p>let y = -2; alert( +y ); // -2</p>
    <p>
      <em>!</em> // Converts non-numbers alert( +true ); // 1 alert( +"" ); // 0
      <em>/!</em> ```
    </p>
    <p>
      It actually does the same thing as <code>Number(...)</code>, but is
      shorter.
    </p>
    <p>
      The need to convert strings to numbers arises very often. For example, if
      we are getting values from HTML form fields, they are usually strings.
      What if we want to sum them?
    </p>
    <p>The binary plus would add them as strings:</p>
    <p>```js run let apples = “2”; let oranges = “3”;</p>
    <p>
      alert(apples + oranges); // “23”, the binary plus concatenates strings ```
    </p>
    <p>
      If we want to treat them as numbers, we need to convert and then sum them:
    </p>
    <p>```js run let apples = “2”; let oranges = “3”;</p>
    <p>
      <em>!</em> // both values converted to numbers before the binary plus
      alert( +apples + +oranges ); // 5 <em>/!</em>
    </p>
    <p>
      // the longer variant // alert( Number(apples) + Number(oranges) ); // 5
      ```
    </p>
    <p>
      From a mathematician’s standpoint, the abundance of pluses may seem
      strange. But from a programmer’s standpoint, there’s nothing special:
      unary pluses are applied first, they convert strings to numbers, and then
      the binary plus sums them up.
    </p>
    <p>
      Why are unary pluses applied to values before the binary ones? As we’re
      going to see, that’s because of their <em>higher precedence</em>.
    </p>
    <h2 id="operator-precedence">Operator precedence</h2>
    <p>
      If an expression has more than one operator, the execution order is
      defined by their <em>precedence</em>, or, in other words, the default
      priority order of operators.
    </p>
    <p>
      From school, we all know that the multiplication in the expression
      <code>1 + 2 * 2</code> should be calculated before the addition. That’s
      exactly the precedence thing. The multiplication is said to have
      <em>a higher precedence</em> than the addition.
    </p>
    <p>
      Parentheses override any precedence, so if we’re not satisfied with the
      default order, we can use them to change it. For example, write
      <code>(1 + 2) * 2</code>.
    </p>
    <p>
      There are many operators in JavaScript. Every operator has a corresponding
      precedence number. The one with the larger number executes first. If the
      precedence is the same, the execution order is from left to right.
    </p>
    <p>
      Here’s an extract from the
      <a
        href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Operators/Operator_Precedence"
        >precedence table</a
      >
      (you don’t need to remember this, but note that unary operators are higher
      than corresponding binary ones):
    </p>
    <table>
      <thead>
        <tr class="header">
          <th>Precedence</th>
          <th>Name</th>
          <th>Sign</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td>…</td>
          <td>…</td>
          <td>…</td>
        </tr>
        <tr class="even">
          <td>17</td>
          <td>unary plus</td>
          <td><code>+</code></td>
        </tr>
        <tr class="odd">
          <td>17</td>
          <td>unary negation</td>
          <td><code>-</code></td>
        </tr>
        <tr class="even">
          <td>16</td>
          <td>exponentiation</td>
          <td><code>**</code></td>
        </tr>
        <tr class="odd">
          <td>15</td>
          <td>multiplication</td>
          <td><code>*</code></td>
        </tr>
        <tr class="even">
          <td>15</td>
          <td>division</td>
          <td><code>/</code></td>
        </tr>
        <tr class="odd">
          <td>13</td>
          <td>addition</td>
          <td><code>+</code></td>
        </tr>
        <tr class="even">
          <td>13</td>
          <td>subtraction</td>
          <td><code>-</code></td>
        </tr>
        <tr class="odd">
          <td>…</td>
          <td>…</td>
          <td>…</td>
        </tr>
        <tr class="even">
          <td>3</td>
          <td>assignment</td>
          <td><code>=</code></td>
        </tr>
        <tr class="odd">
          <td>…</td>
          <td>…</td>
          <td>…</td>
        </tr>
      </tbody>
    </table>
    <p>
      As we can see, the “unary plus” has a priority of <code>17</code> which is
      higher than the <code>13</code> of “addition” (binary plus). That’s why,
      in the expression <code>"+apples + +oranges"</code>, unary pluses work
      before the addition.
    </p>
    <h2 id="assignment">Assignment</h2>
    <p>
      Let’s note that an assignment <code>=</code> is also an operator. It is
      listed in the precedence table with the very low priority of
      <code>3</code>.
    </p>
    <p>
      That’s why, when we assign a variable, like <code>x = 2 * 2 + 1</code>,
      the calculations are done first and then the <code>=</code> is evaluated,
      storing the result in <code>x</code>.
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">let</span> x <span class="op">=</span> <span class="dv">2</span> <span class="op">*</span> <span class="dv">2</span> <span class="op">+</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-2" title="2"></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="at">alert</span>(x)<span class="op">;</span> <span class="co">// 5</span></a></code></pre>
    </div>
    <h3 id="assignment-returns-a-value">Assignment = returns a value</h3>
    <p>
      The fact of <code>=</code> being an operator, not a “magical” language
      construct has an interesting implication.
    </p>
    <p>
      All operators in JavaScript return a value. That’s obvious for
      <code>+</code> and <code>-</code>, but also true for <code>=</code>.
    </p>
    <p>
      The call <code>x = value</code> writes the <code>value</code> into
      <code>x</code> <em>and then returns it</em>.
    </p>
    <p>
      Here’s a demo that uses an assignment as part of a more complex
      expression:
    </p>
    <p>```js run let a = 1; let b = 2;</p>
    <p><em>!</em> let c = 3 - (a = b + 1); <em>/!</em></p>
    <p>alert( a ); // 3 alert( c ); // 0 ```</p>
    <p>
      In the example above, the result of expression <code>(a = b + 1)</code> is
      the value which was assigned to <code>a</code> (that is <code>3</code>).
      It is then used for further evaluations.
    </p>
    <p>
      Funny code, isn’t it? We should understand how it works, because sometimes
      we see it in JavaScript libraries.
    </p>
    <p>
      Although, please don’t write the code like that. Such tricks definitely
      don’t make code clearer or readable.
    </p>
    <h3 id="chaining-assignments">Chaining assignments</h3>
    <p>Another interesting feature is the ability to chain assignments:</p>
    <p>```js run let a, b, c;</p>
    <p><em>!</em> a = b = c = 2 + 2; <em>/!</em></p>
    <p>alert( a ); // 4 alert( b ); // 4 alert( c ); // 4 ```</p>
    <p>
      Chained assignments evaluate from right to left. First, the rightmost
      expression <code>2 + 2</code> is evaluated and then assigned to the
      variables on the left: <code>c</code>, <code>b</code> and <code>a</code>.
      At the end, all the variables share a single value.
    </p>
    <p>
      Once again, for the purposes of readability it’s better to split such code
      into few lines:
    </p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1">c <span class="op">=</span> <span class="dv">2</span> <span class="op">+</span> <span class="dv">2</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-2" title="2">b <span class="op">=</span> c<span class="op">;</span></a>
<a class="sourceLine" id="cb3-3" title="3">a <span class="op">=</span> c<span class="op">;</span></a></code></pre>
    </div>
    <p>That’s easier to read, especially when eye-scanning the code fast.</p>
    <h2 id="modify-in-place">Modify-in-place</h2>
    <p>
      We often need to apply an operator to a variable and store the new result
      in that same variable.
    </p>
    <p>For example:</p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">let</span> n <span class="op">=</span> <span class="dv">2</span><span class="op">;</span></a>
<a class="sourceLine" id="cb4-2" title="2">n <span class="op">=</span> n <span class="op">+</span> <span class="dv">5</span><span class="op">;</span></a>
<a class="sourceLine" id="cb4-3" title="3">n <span class="op">=</span> n <span class="op">*</span> <span class="dv">2</span><span class="op">;</span></a></code></pre>
    </div>
    <p>
      This notation can be shortened using the operators <code>+=</code> and
      <code>*=</code>:
    </p>
    <p>
      ```js run let n = 2; n += 5; // now n = 7 (same as n = n + 5) n
      <em>= 2; // now n = 14 (same as n = n </em> 2)
    </p>
    <p>alert(n); // 14 ```</p>
    <p>
      Short “modify-and-assign” operators exist for all arithmetical and bitwise
      operators: <code>/=</code>, <code>-=</code>, etc.
    </p>
    <p>
      Such operators have the same precedence as a normal assignment, so they
      run after most other calculations:
    </p>
    <p>```js run let n = 2;</p>
    <p>n *= 3 + 5;</p>
    <p>alert(n); // 16 (right part evaluated first, same as n *= 8) ```</p>
    <h2 id="incrementdecrement">Increment/decrement</h2>
    <!-- Can't use -- in title, because the built-in parser turns it into a 'long dash' – -->
    <p>
      Increasing or decreasing a number by one is among the most common
      numerical operations.
    </p>
    <p>So, there are special operators for it:</p>
    <ul>
      <li>
        <p>
          <strong>Increment</strong> <code>++</code> increases a variable by 1:
        </p>
        <p>
          <code
            >js run no-beautify let counter = 2; counter++; // works the same as
            counter = counter + 1, but is shorter alert(counter); // 3</code
          >
        </p>
      </li>
      <li>
        <p>
          <strong>Decrement</strong> <code>--</code> decreases a variable by 1:
        </p>
        <p>
          <code
            >js run no-beautify let counter = 2; counter--; // works the same as
            counter = counter - 1, but is shorter alert(counter); // 1</code
          >
        </p>
      </li>
    </ul>
    <pre
      class="warn"
    ><code>Increment/decrement can only be applied to variables. Trying to use it on a value like `5++` will give an error.</code></pre>
    <p>
      The operators <code>++</code> and <code>--</code> can be placed either
      before or after a variable.
    </p>
    <ul>
      <li>
        When the operator goes after the variable, it is in “postfix form”:
        <code>counter++</code>.
      </li>
      <li>
        The “prefix form” is when the operator goes before the variable:
        <code>++counter</code>.
      </li>
    </ul>
    <p>
      Both of these statements do the same thing: increase
      <code>counter</code> by <code>1</code>.
    </p>
    <p>
      Is there any difference? Yes, but we can only see it if we use the
      returned value of <code>++/--</code>.
    </p>
    <p>
      Let’s clarify. As we know, all operators return a value.
      Increment/decrement is no exception. The prefix form returns the new value
      while the postfix form returns the old value (prior to
      increment/decrement).
    </p>
    <p>To see the difference, here’s an example:</p>
    <p>```js run let counter = 1; let a = ++counter; // (*)</p>
    <p>alert(a); // <em>!</em>2<em>/!</em> ```</p>
    <p>
      In the line <code>(*)</code>, the <em>prefix</em> form
      <code>++counter</code> increments <code>counter</code> and returns the new
      value, <code>2</code>. So, the <code>alert</code> shows <code>2</code>.
    </p>
    <p>Now, let’s use the postfix form:</p>
    <p>
      ```js run let counter = 1; let a = counter++; // (*) changed ++counter to
      counter++
    </p>
    <p>alert(a); // <em>!</em>1<em>/!</em> ```</p>
    <p>
      In the line <code>(*)</code>, the <em>postfix</em> form
      <code>counter++</code> also increments <code>counter</code> but returns
      the <em>old</em> value (prior to increment). So, the
      <code>alert</code> shows <code>1</code>.
    </p>
    <p>To summarize:</p>
    <ul>
      <li>
        <p>
          If the result of increment/decrement is not used, there is no
          difference in which form to use:
        </p>
        <p>
          <code
            >js run let counter = 0; counter++; ++counter; alert(counter); // 2,
            the lines above did the same</code
          >
        </p>
      </li>
      <li>
        <p>
          If we’d like to increase a value <em>and</em> immediately use the
          result of the operator, we need the prefix form:
        </p>
        <p><code>js run let counter = 0; alert(++counter); // 1</code></p>
      </li>
      <li>
        <p>
          If we’d like to increment a value but use its previous value, we need
          the postfix form:
        </p>
        <p><code>js run let counter = 0; alert(counter++); // 0</code></p>
      </li>
    </ul>
    <p>
      ```<code
        >smart header="Increment/decrement among other operators" The
        operators</code
      >++/–` can be used inside expressions as well. Their precedence is higher
      than most other arithmetical operations.
    </p>
    <p>For instance:</p>
    <p><code>js run let counter = 1; alert( 2 * ++counter ); // 4</code></p>
    <p>Compare with:</p>
    <p>
      <code
        >js run let counter = 1; alert( 2 * counter++ ); // 2, because counter++
        returns the "old" value</code
      >
    </p>
    <p>
      Though technically okay, such notation usually makes code less readable.
      One line does multiple things – not good.
    </p>
    <p>
      While reading code, a fast “vertical” eye-scan can easily miss something
      like <code>counter++</code> and it won’t be obvious that the variable
      increased.
    </p>
    <p>We advise a style of “one line – one action”:</p>
    <p>
      <code>js run let counter = 1; alert( 2 * counter ); counter++;</code> ````
    </p>
    <h2 id="bitwise-operators">Bitwise operators</h2>
    <p>
      Bitwise operators treat arguments as 32-bit integer numbers and work on
      the level of their binary representation.
    </p>
    <p>
      These operators are not JavaScript-specific. They are supported in most
      programming languages.
    </p>
    <p>The list of operators:</p>
    <ul>
      <li>AND ( <code>&amp;</code> )</li>
      <li>OR ( <code>|</code> )</li>
      <li>XOR ( <code>^</code> )</li>
      <li>NOT ( <code>~</code> )</li>
      <li>LEFT SHIFT ( <code>&lt;&lt;</code> )</li>
      <li>RIGHT SHIFT ( <code>&gt;&gt;</code> )</li>
      <li>ZERO-FILL RIGHT SHIFT ( <code>&gt;&gt;&gt;</code> )</li>
    </ul>
    <p>
      These operators are used very rarely, when we need to fiddle with numbers
      on the very lowest (bitwise) level. We won’t need these operators any time
      soon, as web development has little use of them, but in some special
      areas, such as cryptography, they are useful. You can read the
      <a
        href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Guide/Expressions_and_Operators#Bitwise"
        >Bitwise Operators</a
      >
      chapter on MDN when a need arises.
    </p>
    <h2 id="comma">Comma</h2>
    <p>
      The comma operator <code>,</code> is one of the rarest and most unusual
      operators. Sometimes, it’s used to write shorter code, so we need to know
      it in order to understand what’s going on.
    </p>
    <p>
      The comma operator allows us to evaluate several expressions, dividing
      them with a comma <code>,</code>. Each of them is evaluated but only the
      result of the last one is returned.
    </p>
    <p>For example:</p>
    <p>```js run <em>!</em> let a = (1 + 2, 3 + 4); <em>/!</em></p>
    <p>alert( a ); // 7 (the result of 3 + 4) ```</p>
    <p>
      Here, the first expression <code>1 + 2</code> is evaluated and its result
      is thrown away. Then, <code>3 + 4</code> is evaluated and returned as the
      result.
    </p>
    <p>
      ``<code
        >smart header="Comma has a very low precedence" Please note that the
        comma operator has very low precedence, lower than</code
      >=`, so parentheses are important in the example above.
    </p>
    <p>
      Without them: <code>a = 1 + 2, 3 + 4</code> evaluates
      <code>+</code> first, summing the numbers into <code>a = 3, 7</code>, then
      the assignment operator <code>=</code> assigns <code>a = 3</code>, and the
      rest is ignored. It’s like <code>(a = 1 + 2), 3 + 4</code>. ```
    </p>
    <p>
      Why do we need an operator that throws away everything except the last
      expression?
    </p>
    <p>
      Sometimes, people use it in more complex constructs to put several actions
      in one line.
    </p>
    <p>For example:</p>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="co">// three operations in one line</span></a>
<a class="sourceLine" id="cb6-2" title="2"><span class="cf">for</span> (<span class="op">*!*</span>a <span class="op">=</span> <span class="dv">1</span><span class="op">,</span> b <span class="op">=</span> <span class="dv">3</span><span class="op">,</span> c <span class="op">=</span> a <span class="op">*</span> b<span class="op">*</span><span class="ss">/!</span><span class="sc">*</span><span class="ss">; a &lt; 10; a</span><span class="sc">++)</span><span class="ss"> {</span></a>
<a class="sourceLine" id="cb6-3" title="3"><span class="ss"> ...</span></a>
<a class="sourceLine" id="cb6-4" title="4"><span class="ss">}</span></a></code></pre>
    </div>
    <p>
      Such tricks are used in many JavaScript frameworks. That’s why we’re
      mentioning them. But usually they don’t improve code readability so we
      should think well before using them.
    </p>
  </body>
</html>
